<template>
  <i-wrapper top>
    <i-header :title="$t(`Place of birth`)" back />
    <i-curtain tag="form" :bottom-circles="false" fixed @submit="save()">
      <div class="container d-flex flex-column align-items-center">
        <img src="~assets/images/bubbles-orange.svg" class="bubbles p-bubbles" />
        <img src="~assets/images/scientist-globe.png" class="p-scientist" />
        <div class="p-title">{{ $t(`Place of birth`) }}</div>
        <div class="p-description">
          {{ $t(`So what city were you born in? Where you're born influences the person you become.`) }}
        </div>
      </div>
      <template #bottom>
        <i-autocomplete ref="birthPlaceInput" v-model="birthPlace" :placeholder="$t(`Type your city`)" />
        <i-button block submit :loading="isLoading" :disabled="isLoading" class="mt-1">{{ $t(`Save`) }}</i-button>
      </template>
    </i-curtain>
  </i-wrapper>
</template>

<script>
  export default {
    layout: 'default',
    nuxtI18n: false,
    middleware: ['logged-in-only'],
    transition: { name: 'fade', mode: 'out-in' },

    data() {
      return {
        birthPlace: this.$store.state.auth.user.birthPlace
          ? {
              key: this.$store.state.auth.user.birthPlace.key,
              description: this.$store.state.auth.user.birthPlace.description.split(/,/)[0].trim(),
            }
          : null,
        isLoading: false,
      };
    },

    methods: {
      async save() {
        if (!this.birthPlace) {
          this.$refs.birthPlaceInput.$refs.autocomplete.$refs.root.classList.add('bounce');

          setTimeout(() => {
            this.$refs.birthPlaceInput.$refs.autocomplete.$refs.root.classList.remove('bounce');
          }, 1000);

          return;
        }

        this.isLoading = true;

        try {
          let response = await this.$axios.post('users/me/update', {
            user: { birthPlaceKey: this.birthPlace.key },
          });

          this.$store.commit('MERGE_AUTH', { user: response.data.data });
          this.$router.go(-1);
        } catch (error) {
          this.isLoading = false;
          throw error;
        }
      },
    },
  };
</script>

<style lang="scss" scoped>
  .p-bubbles {
    top: rs(147px);
  }

  .p-scientist {
    width: rs(112px);
    margin-top: rs(48px);
  }

  .p-title {
    font-size: rf(20px);
    color: #575167;
    font-weight: bold;
    margin-top: rs(4px);
  }

  .p-description {
    font-size: rf(16px);
    color: #575167;
    text-align: center;
    margin-top: rs(5px);
  }

  .p-birth-date-input {
    margin-top: rs(50px);
  }

  .p-birth-time-input {
    margin-top: rs(24px);
  }

  .p-checkbox {
    width: 100%;
    margin-top: rs(24px);
  }
</style>
